package risiko.common.interfaces;

import java.io.Serializable;
import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Interface zum Valueobject
 * 
 * @author dgrosche
 * @version 2009-07-01
 *
 */
public interface Mission extends Remote, Serializable {

	/**
	 * Prft ob Mission erfllt wurde
	 */
	public abstract void pruefErfuellt() throws RemoteException;

	/**
	 * @param p the spieler to set
	 */
	public abstract void setSpieler(Spieler p) throws RemoteException;

	/**
	 * @return the erfuellt
	 */
	public abstract boolean isErfuellt() throws RemoteException;

	/**
	 * @param s the message to set
	 */
	public abstract void setMessage(String s) throws RemoteException;
	
	/**
	 * @return the message
	 */
	public abstract String getMessage() throws RemoteException; 

}